// AdoQueryForm.cpp : implementation file
//

#include "stdafx.h"
#include "adorecordsetview.h"
#include "AdoQueryForm.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdoQueryForm dialog

CAdoQueryForm::CAdoQueryForm(CWnd* pParent /*=NULL*/)
	: CExtNCW < CExtResizableDialog > ( CAdoQueryForm::IDD, pParent )
{
	//{{AFX_DATA_INIT(CAdoQueryForm)
	//}}AFX_DATA_INIT
	m_hIcon = ::AfxGetApp()->LoadIcon( IDR_MAINFRAME );
	ASSERT( m_hIcon != NULL );
}

CAdoQueryForm::~CAdoQueryForm()
{
	if( m_hIcon != NULL )
		::DestroyIcon( m_hIcon );
}

void CAdoQueryForm::DoDataExchange(CDataExchange* pDX)
{
	CExtNCW < CExtResizableDialog > :: DoDataExchange( pDX );
	//{{AFX_DATA_MAP(CAdoQueryForm)
	DDX_Control(pDX, IDC_CHECK_VIRTUAL_MODE, m_checkVirtualMode);
	DDX_Control(pDX, IDC_EDIT_SQL_QUERY, m_editSqlQuery);
	DDX_Control(pDX, IDC_EDIT_CONNECTION_STRING, m_editConnectionString);
	DDX_Control(pDX, ID_COMPOSE_CONNECTION_STRING, m_btnCompose);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDC_STATIC1, m_label1);
	DDX_Control(pDX, IDC_STATIC2, m_label2);
	DDX_Control(pDX, IDC_STATIC3, m_label3);
	DDX_Control(pDX, IDC_STATIC4, m_label4);
	DDX_Control(pDX, IDC_STATIC5, m_label5);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP( CAdoQueryForm, CExtResizableDialog )
	//{{AFX_MSG_MAP(CAdoQueryForm)
	ON_BN_CLICKED(ID_COMPOSE_CONNECTION_STRING, OnComposeConnectionString)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdoQueryForm message handlers

BOOL CAdoQueryForm::OnInitDialog() 
{
	if( ! CExtNCW < CExtResizableDialog > :: OnInitDialog() )
	{
		ASSERT( FALSE );
		return FALSE;
	}
	if( m_hIcon != NULL )
	{
		SetIcon( m_hIcon, TRUE );
		SetIcon( m_hIcon, FALSE );
	}
CMainFrame * pMainFrame =
		STATIC_DOWNCAST(
			CMainFrame,
			GetParentFrame()
			);
	ASSERT_VALID( pMainFrame );
	m_editConnectionString.SetWindowText(
		pMainFrame->m_strAdoConnection.IsEmpty()
			? _T("")
			: LPCTSTR(pMainFrame->m_strAdoConnection)
		);
	m_editSqlQuery.SetWindowText(
		pMainFrame->m_strSqlQuery.IsEmpty()
			? _T("")
			: LPCTSTR(pMainFrame->m_strSqlQuery)
		);
	AddAnchor( IDC_EDIT_CONNECTION_STRING, __RDA_LT, __RDA_RT );
	AddAnchor( ID_COMPOSE_CONNECTION_STRING, __RDA_RT );
	AddAnchor( IDC_EDIT_SQL_QUERY, __RDA_LT, __RDA_RB );
	AddAnchor( IDOK, CSize(50,100) );
	AddAnchor( IDCANCEL, CSize(50,100) );
	EnableSaveRestore( _T("Resizable forms"), _T("Query") );
	return TRUE;
}

CString CAdoQueryForm::stat_CString_from_bstr( BSTR _bstr )
{
	USES_CONVERSION;
	return CString( OLE2CT(_bstr) );
}

void CAdoQueryForm::OnComposeConnectionString() 
{
	try
	{
		try
		{
			CString strConnectionString;
			CMainFrame * pMainFrame =
				STATIC_DOWNCAST(
					CMainFrame,
					GetParentFrame()
					);
			ASSERT_VALID( pMainFrame );
			m_editConnectionString.GetWindowText( strConnectionString );
			CComPtr < IUnknown > objDataLinks;
			HRESULT hr = objDataLinks.CoCreateInstance( __uuidof(MSDASC::DataLinks) );
			// we need the MSDASC::IDataSourceLocator
			CComQIPtr < MSDASC::IDataSourceLocator > objDataSourceLocator = objDataLinks;
			if( FAILED(hr) )
			{
				CString strMsg;
				strMsg.Format(
					_T("Failed to create the OLE-DB data source locator (HRESULT = %ld = 0x%08X)"),
					hr, hr
					);
				::AfxMessageBox( strMsg, MB_ICONERROR );
				return;
			}
			ASSERT( objDataSourceLocator != NULL );
			objDataSourceLocator->PuthWnd( LONG(m_hWnd) );
			CComQIPtr < ADODB::_Connection > objAdoConnection;
			if( strConnectionString.IsEmpty() )
			{
				objAdoConnection = objDataSourceLocator->PromptNew();
			} // if( strConnectionString.IsEmpty() )
			else
			{
				hr = objAdoConnection.CoCreateInstance( __uuidof(ADODB::Connection) );
				if( FAILED(hr) )
				{
					CString strMsg;
					strMsg.Format(
						_T("Failed to create the template ADO database connection that is required for the connection string editing in the standard OLE-DB form (HRESULT = %ld = 0x%08X)"),
						hr, hr
						);
					::AfxMessageBox( strMsg, MB_ICONERROR );
					return;
				}
				USES_CONVERSION;
				objAdoConnection->ConnectionString = T2COLE( LPCTSTR(strConnectionString) );
				VARIANT_BOOL bRetVal = objDataSourceLocator->PromptEdit( (IDispatch**)&objAdoConnection.p );
				if( bRetVal == VARIANT_FALSE )
					return;
			} // else from if( strConnectionString.IsEmpty() )
			if( objAdoConnection == NULL )
				return;
			_bstr_t bstrConnectionString = objAdoConnection->ConnectionString;
			strConnectionString = stat_CString_from_bstr( bstrConnectionString );
			m_editConnectionString.SetWindowText( strConnectionString.IsEmpty() ? _T("") : LPCTSTR(strConnectionString) );
			return;
		} // try
		catch( _com_error & _ce )
		{
			HRESULT hr = _ce.Error();
			_bstr_t bstrDescription = _ce.Description();
			LPCTSTR strErrorMessage = _ce.ErrorMessage();
			CString strDescription = stat_CString_from_bstr( bstrDescription );
			CString strMsg;
			strMsg.Format(
				_T("COM error caught (HRESULT = %ld = 0x%08X, Description=\"%s\", ErrorMessage=\"%s\")"),
				hr, hr,
				strDescription.IsEmpty() ? _T("") : strDescription,
				( strErrorMessage == NULL ) ? _T("") : strErrorMessage
				);
			::AfxMessageBox( strMsg, MB_ICONERROR );
		} // catch( _com_error & _ce )
		catch( CException * pException )
		{
			pException->ReportError( MB_ICONERROR );
			pException->Delete();
		} // catch( CException * pException )
		catch( ... )
		{
			::AfxMessageBox( _T("Unknown exception caught."), MB_ICONERROR );
		} // catch( ... )
	} // try
	catch( ... )
	{
	} // catch( ... )
}

void CAdoQueryForm::OnOK() 
{
	try
	{
		try
		{
			if( m_objAdoRS != NULL )
				m_objAdoRS.Release();
			CString strConnectionString, strSqlQuery;
			CMainFrame * pMainFrame =
				STATIC_DOWNCAST(
					CMainFrame,
					GetParentFrame()
					);
			ASSERT_VALID( pMainFrame );
			m_editConnectionString.GetWindowText( strConnectionString );
			m_editSqlQuery.GetWindowText( strSqlQuery );
			ADODB::_ConnectionPtr objAdoConnection;
			HRESULT hr = objAdoConnection.CreateInstance( __uuidof(ADODB::Connection) );
			if( FAILED(hr) )
			{
				CString strMsg;
				strMsg.Format(
					_T("Failed to create the ADO database connection (HRESULT = %ld = 0x%08X)"),
					hr, hr
					);
				::AfxMessageBox( strMsg, MB_ICONERROR );
				return;
			}
			_bstr_t bstrUserID( "" );
			_bstr_t bstrPassword( "" );
			long nOptions = 0L;
			USES_CONVERSION;
			hr =
				objAdoConnection->Open(
					T2COLE( LPCTSTR(strConnectionString) ),
					bstrUserID,
					bstrPassword,
					nOptions
					);
			if( FAILED(hr) )
			{
				CString strMsg;
				strMsg.Format(
					_T("Failed to open the ADO database connection (ConnectionString=\"%s\", HRESULT = %ld = 0x%08X)"),
					LPCTSTR(strConnectionString), hr, hr
					);
				::AfxMessageBox( strMsg, MB_ICONERROR );
				return;
			}
			
			hr = m_objAdoRS.CreateInstance( __uuidof(ADODB::Recordset) );
			if( FAILED(hr) )
			{
				CString strMsg;
				strMsg.Format(
					_T("Failed to create the ADO recordset (HRESULT = %ld = 0x%08X)"),
					hr, hr
					);
				::AfxMessageBox( strMsg, MB_ICONERROR );
				return;
			}
			
			ADODB::CursorTypeEnum_ADO nCursorType =
				m_checkVirtualMode.GetCheck()
					? ADODB::adOpenKeyset
					: ADODB::adOpenStatic;
			m_objAdoRS->PutRefActiveConnection( objAdoConnection );
			hr =
				m_objAdoRS->Open(
					T2COLE( LPCTSTR(strSqlQuery) ),
					vtMissing,
					nCursorType,
					ADODB::adLockReadOnly,
					ADODB::adOptionUnspecified
					);

			ADODB::CursorTypeEnum_ADO nCursorTypeReal = (ADODB::CursorTypeEnum_ADO)m_objAdoRS->GetCursorType_ADO();
			if( nCursorTypeReal != nCursorType )
			{
				CString strMsg = _T("The opened ADO recordset object has changed the requested record scrolling type to **");
				switch( nCursorTypeReal )
				{
				case ADODB::adOpenUnspecified:
					strMsg += _T("adOpenUnspecified");
				break;
				case ADODB::adOpenForwardOnly:
					strMsg += _T("adOpenForwardOnly");
				break;
				case ADODB::adOpenKeyset:
					strMsg += _T("adOpenKeyset");
				break;
				case ADODB::adOpenDynamic:
					strMsg += _T("adOpenDynamic");
				break;
				case ADODB::adOpenStatic:
					strMsg += _T("adOpenStatic");
				break;
				default:
					{
						LONG nValue = (LONG)nCursorTypeReal;
						CString strValue;
						strValue.Format( _T("%ld(0x%08X)"), nValue, nValue );
						strMsg += strValue;
					}
				break;
				} // switch( nCursorTypeReal )
				strMsg += _T("**\n(this may caused by limited cursor library implementation of currently used OLE-DB provider)");
				::AfxMessageBox( strMsg, MB_ICONWARNING );
			} // if( nCursorTypeReal != nCursorType )

			// remember settings
			pMainFrame->m_strAdoConnection = strConnectionString;
			pMainFrame->m_strSqlQuery = strSqlQuery;
			CExtNCW < CExtResizableDialog > :: OnOK();
			return;
		} // try
		catch( _com_error & _ce )
		{
			HRESULT hr = _ce.Error();
			_bstr_t bstrDescription = _ce.Description();
			CString strErrorMessage = _ce.ErrorMessage();
			CString strDescription = stat_CString_from_bstr( bstrDescription );
			CString strMsg;
			strMsg.Format(
				_T("COM error caught (HRESULT = %ld = 0x%08X, Description=\"%s\", ErrorMessage=\"%s\")"),
				long(hr), int(hr),
				(strDescription.IsEmpty()) ? _T("") : LPCTSTR(strDescription),
				(strErrorMessage.IsEmpty()) ? _T("") : LPCTSTR(strErrorMessage)
				);
			::AfxMessageBox( strMsg, MB_ICONERROR );
		} // catch( _com_error & _ce )
		catch( CException * pException )
		{
			pException->ReportError( MB_ICONERROR );
			pException->Delete();
		} // catch( CException * pException )
		catch( ... )
		{
			::AfxMessageBox( _T("Unknown exception caught."), MB_ICONERROR );
		} // catch( ... )
		
		if( m_objAdoRS != NULL )
			m_objAdoRS.Release();
	} // try
	catch( ... )
	{
	} // catch( ... )
}

